"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
const _utils_1 = require("../utils");
const _constants_1 = require("../constants");
class Metadata {
    static get(key, target, propertyKey) {
        return Reflect.getMetadata(key, _utils_1.getClass(target), propertyKey);
    }
    static set(key, value, target, propertyKey) {
        return propertyKey
            ? Reflect.defineMetadata(key, value, _utils_1.getClass(target), propertyKey)
            : Reflect.defineMetadata(key, value, _utils_1.getClass(target));
    }
    static getOwn(key, target, propertyKey) {
        return propertyKey
            ? Reflect.getOwnMetadata(key, _utils_1.getClass(target), propertyKey)
            : Reflect.getOwnMetadata(key, _utils_1.getClass(target));
    }
    static getType(target, propertyKey) {
        return Reflect.getMetadata(_constants_1.DESIGN_TYPE, target, propertyKey);
    }
}
exports.Metadata = Metadata;
//# sourceMappingURL=Metadata.js.map