"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const _decorators_1 = require("../decorators");
const _common_1 = require("../common");
const Lenneth_error_1 = require("./Lenneth-error");
let LennethResponse = class LennethResponse {
    async use(response, next, ctx) {
        try {
            await next();
            let body = response.body || ctx.body;
            if (body) {
                return (response.body = {
                    code: 0,
                    message: _common_1.ResponseStatus.SUCCESS,
                    data: response.body
                });
            }
            return (response.body = { code: 0, message: _common_1.ResponseStatus.SUCCESS });
        }
        catch (err) {
            ctx.status = err.code;
            response.status = _common_1.HttpStatus.OK;
            if (err instanceof Lenneth_error_1.LennethError) {
                response.body = {
                    code: err.code,
                    message: err.message || _common_1.ResponseStatus.ERROR
                };
            }
            else {
                response.body = {
                    code: err.code || _common_1.HttpStatus.INTERNAL_SERVER_ERROR,
                    message: err.message || _common_1.ResponseStatus.ERROR
                };
                throw err;
            }
        }
    }
};
tslib_1.__decorate([
    tslib_1.__param(0, _decorators_1.Response()),
    tslib_1.__param(1, _decorators_1.Next()),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [Object, Function, Object]),
    tslib_1.__metadata("design:returntype", Promise)
], LennethResponse.prototype, "use", null);
LennethResponse = tslib_1.__decorate([
    _decorators_1.Middleware()
], LennethResponse);
exports.LennethResponse = LennethResponse;
//# sourceMappingURL=lenneth-response.js.map