"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const _common_1 = require("../common");
const _constants_1 = require("../constants");
const _decorators_1 = require("../decorators");
const debug_controller_1 = require("./debug.controller");
const lenneth_error_1 = require("./lenneth-error");
const lenneth_response_1 = require("./lenneth-response");
const rootDir = process.cwd();
const env = process.env.NODE_ENV || _common_1.Env.DEV;
class LennethSetting {
    getMetadata(target) {
        return _common_1.Metadata.getOwn(_constants_1.SERVER_SETTINGS, target);
    }
    setMap(propertyKey, value) {
        if (typeof propertyKey == "string") {
            LennethSetting.serverSettingMap.set(propertyKey, value);
        }
        else {
            let setting = Object.assign({ rootDir: this.rootDir, port: this.port, env: this.env, globalError: this.globalError, response: this.response, logFileSetting: this.logFileSetting }, propertyKey);
            let _imports = this.imports;
            let imports = setting["imports"];
            setting["imports"] = Object.assign({}, imports, _imports);
            Object.keys(setting).forEach(key => {
                this.setMap(key, setting[key]);
            });
        }
    }
    getHttpPort() {
        let hostname = "0.0.0.0";
        return { hostname, port: LennethSetting.serverSettingMap.get("port") };
    }
}
LennethSetting.serverSettingMap = new Map();
tslib_1.__decorate([
    _decorators_1.Value(rootDir),
    tslib_1.__metadata("design:type", String)
], LennethSetting.prototype, "rootDir", void 0);
tslib_1.__decorate([
    _decorators_1.Value(8080),
    tslib_1.__metadata("design:type", Object)
], LennethSetting.prototype, "port", void 0);
tslib_1.__decorate([
    _decorators_1.Value(env),
    tslib_1.__metadata("design:type", String)
], LennethSetting.prototype, "env", void 0);
tslib_1.__decorate([
    _decorators_1.Value({ "/debug": debug_controller_1.DebugController }),
    tslib_1.__metadata("design:type", Object)
], LennethSetting.prototype, "imports", void 0);
tslib_1.__decorate([
    _decorators_1.Value(lenneth_error_1.LennethGlobalError),
    tslib_1.__metadata("design:type", Function)
], LennethSetting.prototype, "globalError", void 0);
tslib_1.__decorate([
    _decorators_1.Value(lenneth_response_1.LennethResponse),
    tslib_1.__metadata("design:type", Function)
], LennethSetting.prototype, "response", void 0);
exports.LennethSetting = LennethSetting;
//# sourceMappingURL=lenneth-setting.js.map