"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _utils_1 = require("../../utils");
exports.Writable = (value = true) => {
    return (target, propertyKey) => {
        const descriptor = _utils_1.descriptorOf(target, propertyKey) || {
            configurable: true,
            enumerable: true
        };
        descriptor.writable = value;
        Object.defineProperty((target && target.prototype) || target, propertyKey, descriptor);
        return descriptor;
    };
};
//# sourceMappingURL=writable.js.map