"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _common_1 = require("../../common");
const _services_1 = require("../../services");
const _utils_1 = require("../../utils");
const decorate = (target, propertyKey, parameterIndex, paramsKey, type) => {
    let paramsMap = _services_1.ParamsService.paramsMap;
    let paramsMapKey = _services_1.ParamsService.fomartParamsMapKey(target, propertyKey);
    let paramsValueList = _utils_1.toArray(paramsMap.get(paramsMapKey));
    paramsValueList[parameterIndex] = {
        parameterIndex,
        paramsType: type,
        paramsKey
    };
    _services_1.ParamsService.paramsMap.set(paramsMapKey, paramsValueList);
};
exports.RequestParam = (paramsKey) => {
    return (target, propertyKey, parameterIndex) => {
        decorate(target, propertyKey, parameterIndex, paramsKey, _common_1.ParamsType.QUERYPARAMS);
    };
};
exports.RequestBody = (paramsKey) => {
    return (target, propertyKey, parameterIndex) => {
        decorate(target, propertyKey, parameterIndex, paramsKey, _common_1.ParamsType.BODYPARAMS);
    };
};
exports.PathVariable = (paramsKey) => {
    return (target, propertyKey, parameterIndex) => {
        decorate(target, propertyKey, parameterIndex, paramsKey, _common_1.ParamsType.PATHPARAMS);
    };
};
exports.Response = () => {
    return (target, propertyKey, parameterIndex) => {
        decorate(target, propertyKey, parameterIndex, "", _common_1.ParamsType.RESPONSE);
    };
};
exports.Request = () => {
    return (target, propertyKey, parameterIndex) => {
        decorate(target, propertyKey, parameterIndex, "", _common_1.ParamsType.REQUEST);
    };
};
exports.HeaderParams = (paramsKey = "") => {
    return (target, propertyKey, parameterIndex) => {
        decorate(target, propertyKey, parameterIndex, paramsKey, _common_1.ParamsType.HEADERPARAMS);
    };
};
exports.Next = () => {
    return (target, propertyKey, parameterIndex) => {
        decorate(target, propertyKey, parameterIndex, "", _common_1.ParamsType.NEXT);
    };
};
exports.Err = () => {
    return (target, propertyKey, parameterIndex) => {
        decorate(target, propertyKey, parameterIndex, "", _common_1.ParamsType.ERROR);
    };
};
//# sourceMappingURL=params.js.map