"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _common_1 = require("../../common");
const _utils_1 = require("../../utils");
exports.Service = () => {
    return target => {
        console.log(`register service ${_utils_1.getClassName(target)}`);
    };
};
exports.Value = (value = "") => {
    return (target, propertyKey) => {
        const descriptor = _utils_1.descriptorOf(target, propertyKey) || {
            writable: true,
            configurable: true
        };
        descriptor.value = value;
        Reflect.defineProperty((target && target.prototype) || target, propertyKey, descriptor);
    };
};
exports.Autowired = (params = "") => {
    return (target, propertyKey) => {
        let typeClass = _common_1.Metadata.getType(target, propertyKey);
        const descriptor = _utils_1.descriptorOf(target, propertyKey) || {
            writable: true,
            configurable: true
        };
        descriptor.value = params ? new typeClass(params) : new typeClass();
        Reflect.defineProperty((target && target.prototype) || target, propertyKey, descriptor);
    };
};
//# sourceMappingURL=index.js.map