"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getClass = (target) => {
    return target.prototype ? target : target.constructor;
};
exports.getClassOrSymbol = (target) => {
    return typeof target === "symbol" ? target : exports.getClass(target);
};
exports.getClassName = (target) => {
    return typeof target === "function" ? target.name : target.constructor.name;
};
exports.isEmpty = (value) => {
    return value === "" || value === null || value === undefined;
};
exports.isArray = (target) => {
    return Array.isArray(target);
};
exports.descriptorOf = (target, propertyKey) => {
    return Reflect.getOwnPropertyDescriptor((target && target.prototype) || target, propertyKey);
};
exports.toArray = (target) => {
    return target ? (Array.isArray(target) ? target : [target]) : [];
};
exports.isJsonString = (str) => {
    try {
        if (typeof JSON.parse(str) == "object") {
            return true;
        }
    }
    catch (e) { }
    return false;
};
exports.apiDescriptionMapKey = (target, propertyKey) => {
    return `${exports.getClassName(target)}_${propertyKey}`;
};
exports.createParamsMapKey = (target, propertyKey) => {
    return `${exports.getClassName(target)}_${propertyKey}`;
};
exports.toAsyncMiddleware = (target, middleware, key, cb) => {
    return async (ctx, next) => {
        if (key) {
            return middleware.call(target, ...cb(key, ctx, next), ctx, next);
        }
        return middleware.call(target, ctx, next);
    };
};
exports.toErrorAsyncMiddleware = (target, middleware, key, cb) => {
    return (err, ctx) => {
        return middleware.call(target, ...cb(key, err, ctx), ctx);
    };
};
//# sourceMappingURL=index.js.map